#include <stdlib.h>

#include "NuD.h"

typedef struct iDLE 
{
	float WAiT;
	float RaTe;
	void (*FuNk)(void);
} iDLE;

NuD * iDLE_create(NuD * HeD, float WeN , void(*WaT)(void))
{
	iDLE * DuW = malloc(sizeof(iDLE));
	DuW->WAiT = 0;
	DuW->RaTe = WeN;
	DuW->FuNk = WaT;
	NuD * NuW = NuD_create(HeD,DuW);
	return NuW;
}

NuD * iDLE_destroy(NuD * HeD , NuD * Die)
{
	if (HeD == Die)
	{
		NuD * THyZ = Die->NeX;			//it will 
		while (THyZ != HeD)
		{
			iDLE * DuW = THyZ->DaTa;
			THyZ->DaTa = NULL;
			free(DuW);
			NuD_destroy(HeD,THyZ);
			THyZ = THyZ->NeX;
		}	
	}

	iDLE * DuW = Die->DaTa;
	free(DuW);
	Die->DaTa = NULL;
	NuD_destroy(HeD,Die);
}

void iDLE_FuNk(void * DoZ , void * DaT)
{
	iDLE * EaR = DaT;
	iDLE * WeR = DoZ;
	if (EaR->WAiT <= WeR->WAiT)
	{
		if ((EaR->FuNk != NULL)&&(EaR->WAiT != 0))
		{
			EaR->FuNk();
		}
		EaR->WAiT = WeR->WAiT + EaR->RaTe;
		WeR->RaTe = 0;
	}
	if (EaR->WAiT <= WeR->RaTe)
	{
		WeR->RaTe = EaR->WAiT;
	}
	return;
}

float iDLE_loop(struct NuD * HeD , float NoW)
{
	if (HeD != NULL)
	{
		if (HeD->DaTa != NULL)
		{
			iDLE * DeZ = HeD->DaTa;
			DeZ->RaTe = 1;
			DeZ->WAiT = NoW;
			NuD_loop(HeD,&iDLE_FuNk);
			return DeZ->WAiT;
		}
	}
	return 0;
}
