#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "NuD.h"
#include "iDLE.h"

int end;

void unfunc(void)
{
	printf("un ");
}

void defunc(void)
{
	printf("deux ");
}

void trfunc(void)
{
	printf("trois ");
}

void enfunc(void)
{
	end = 1;
}

void spfunc(void)
{
	printf("\n");
}

int main(void)
{
	printf ("NOiD iDLE system\n");

	NuD * ceci = iDLE_create(NULL,0,NULL);
	iDLE_create(ceci,1,&spfunc);
	iDLE_create(ceci,1,&unfunc);
	iDLE_create(ceci,2,&defunc);
	iDLE_create(ceci,3,&trfunc);
	iDLE_create(ceci,7,&enfunc);
	end = 0;
	while (end == 0)
	{
		float time = ((float)clock()) / (CLOCKS_PER_SEC);
		iDLE_loop(ceci,time);
	}
	NuD_destroy(ceci,ceci);

	return 0;
}
